"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const DrawerToggle_1 = __importDefault(require("./DrawerToggle"));
const Tabs_1 = __importDefault(require("./Tabs"));
const react_shared_1 = require("@dgui/react-shared");
const react_web_1 = require("@dgui/react-web");
const react_1 = require("react");
const styles = {
    appBar: {
        alignItems: 'center',
        backgroundColor: '#CCC',
        boxShadow: '0 0 10px 5px rgba(0, 0, 0, 0.1)',
        display: 'flex',
        flexDirection: 'row',
        position: 'relative',
        zIndex: 102
    }
};
const AppBar = (_a) => {
    var { appBarStyle: givenAppBarStyle, children, icon, tabBarStyle } = _a, props = __rest(_a, ["appBarStyle", "children", "icon", "tabBarStyle"]);
    const appBarStyle = (0, react_1.useMemo)(() => {
        return Object.assign(Object.assign({}, styles.appBar), givenAppBarStyle);
    }, [
        givenAppBarStyle
    ]);
    const selectTab = (0, react_shared_1.useSelectTab)();
    const tabIndex = (0, react_shared_1.useTabIndex)();
    const handleSelectTab = (0, react_1.useCallback)((index) => {
        selectTab(index);
    }, [
        selectTab
    ]);
    const tabOrder = (0, react_shared_1.useTabOrder)();
    const tabs = (0, react_shared_1.useTabs)();
    const routes = (0, react_1.useMemo)(() => {
        return tabOrder.map((tabId) => {
            var _a, _b, _c, _d;
            return {
                accessibilityLabel: (_b = (_a = tabs[tabId]) === null || _a === void 0 ? void 0 : _a.title) !== null && _b !== void 0 ? _b : tabId,
                icon: undefined,
                key: tabId,
                title: (_d = (_c = tabs[tabId]) === null || _c === void 0 ? void 0 : _c.title) !== null && _d !== void 0 ? _d : tabId
            };
        });
    }, [
        tabOrder,
        tabs
    ]);
    return ((0, jsx_runtime_1.jsx)(react_web_1.ReactWebDigestAppBar, { children: (0, jsx_runtime_1.jsxs)("div", { style: appBarStyle, children: [(0, jsx_runtime_1.jsx)(DrawerToggle_1.default, { icon: icon }), (0, jsx_runtime_1.jsx)(Tabs_1.default, Object.assign({}, props, { defaultIndex: tabIndex, onSelectTab: handleSelectTab, routes: routes, style: tabBarStyle })), children] }) }));
};
exports.default = AppBar;
//# sourceMappingURL=AppBar.js.map